( 3iOLED_SSD1306.fs - 2021-06-03---Thu---14:24 )
( GForth file for communicating directly with OLED display's SSD1306 driver IC, allowing for bare metal development, with use of e.g. Adafruit's SSD1306 device driver software or their GFX graphics library. )
( Writing this by translating the driver software into Forth.  )
( There is so much to discard in C! C code feels like obfuscation-ware )


\ need I2C communication primitives (see Wire.h/.cpp)
\ Excellent tutorial: https://mansfield-devine.com/speculatrix/2018/02/avr-basics-using-the-i2c-bus-2-transmitting/
\ primitive is Arduino's setClock() function which sets clock speed / crystal
\ safe default for I2C is 100 kHz (standard speed) or 400 kHz (fast).  Nano clock speed is 16MHz.
\ CPU frequency is scaled so it cannot generate all possible frequencies

  uint32_t     wireClk;    // Wire speed for SSD1306 transfers
  uint32_t     restoreClk; // Wire speed following SSD1306 transfers

: setclk
    TWBR = ((F_CPU / frequency) - 16) / 2;  \ sets register  .e.g. 16000 / 100 ->72  - note this uses TWI (two-wire interface)
;

: setwireclock  // SETWIRECLOCK
    wire->setClock(wireClk)    ///< Set before I2C transfer
;
: restorewireclock  // RESWIRECLOCK
     wire->setClock(restoreClk) ///< Restore after I2C xfer
;

: i2c-start  \ start i2c transaction
  xxx setclk 
;

: i2c-end  \ end i2c transaction
  xxx setclk
;
